#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 clrGreen
#property indicator_width1 4
#property indicator_color2 clrRed
#property indicator_width2 4
#property indicator_color3 Teal
#property indicator_color4 Teal
#property indicator_color5 Black

#property indicator_minimum 0
#property indicator_maximum 0.1

extern int Amplitude = 2;

extern bool   alertsOn        = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundfile       = "alert2.wav";

bool nexttrend;
double minh, maxl, up[], down[], trend[], atrlo[], atrhi[];

int init () {
   SetIndexBuffer(0, up);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexLabel(0, "up");
   
   SetIndexBuffer(1, down);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexLabel(1, "down");
   
  SetIndexBuffer (2, atrlo);
  SetIndexStyle (2, DRAW_NONE);
  SetIndexBuffer (3, atrhi);
  SetIndexStyle (3, DRAW_NONE);
  SetIndexBuffer (4, trend);
  

   //---
   
   
   
  SetIndexEmptyValue (0, 0.0);
  SetIndexEmptyValue (1, 0.0);
  SetIndexEmptyValue (4, 0.0);
  nexttrend = 0;
  minh = High[Bars - 1];
  maxl = Low[Bars - 1];
  return (0);
}

int start () {


     
  double atr, ll, hh, lma, hma;
  int workbar = 1;
  int c = IndicatorCounted ();

  if (c < 0) {
    return (- 1);
  }

  for (int i = Bars - 1 - c; i >= workbar; i --) {
    ll = iLow (Symbol (), Period (),
      iLowest (Symbol (), Period (), MODE_LOW, Amplitude, i));
    hh = iHigh (Symbol (), Period (),
      iHighest (Symbol (), Period (), MODE_HIGH, Amplitude, i));
    lma = iMA (NULL, 0, Amplitude, 0, MODE_SMA, PRICE_LOW, i);
    hma = iMA (NULL, 0, Amplitude, 0, MODE_SMA, PRICE_HIGH, i);
    trend[i] = trend[i + 1];
    atr = iATR (Symbol (), 0, 100, i) / 2;

    if (nexttrend == 1) {
      maxl = MathMax (ll, maxl);

      if (hma < maxl && Close[i] < Low[i + 1]) {
        trend[i] = 1;
        nexttrend = 0;
        minh = hh;
      }
    }

    if (nexttrend == 0) {
      minh = MathMin (hh, minh);

      if (lma > minh && Close[i] > High[i + 1]) {
        trend[i] = 0;
        nexttrend = 1;
        maxl = ll;
      }
    }

    if (trend[i] == 0.0) { //-------------------------------------------------------------------------------------------
      if (trend[i + 1] != 0.0) {
        up[i] = down[i + 1];
        up[i + 1] = up[i];
      } else {
        up[i] = MathMax (maxl, up[i + 1]);
      }

      atrhi[i] = up[i] + atr;
      atrlo[i] = up[i] - atr;
      down[i] = 0.0;

    } else {
      if (trend[i + 1] != 1.0) {
        down[i] = up[i + 1];//-------------------------------------------------------------------------------------------
        down[i + 1] = down[i];
      } else {
        down[i] = MathMin (minh, down[i + 1]);
      }

      atrhi[i] = down[i] + atr;
      atrlo[i] = down[i] - atr;
      up[i] = 0.0; //-------------------------------------------------------------------------------------------

    }
    
    if(alertsOn){
                  if((up[2]!=EMPTY_VALUE) && (down[2]!=EMPTY_VALUE) &&(up[1]!=EMPTY_VALUE)&&(down[1]==EMPTY_VALUE))lcheckalert();       
                  if((up[2]!=EMPTY_VALUE) && (down[2]==EMPTY_VALUE) &&(up[1]!=EMPTY_VALUE)&&(down[1]!=EMPTY_VALUE))scheckalert();
                }
  }

  return (0);
}


void lcheckalert()
{
 
   static datetime candletime=0;
  
   if(candletime!=Time[0])
     {
               
             string lmessage = "ZOXY is green on, this means a buy signal! Pair:"+_Symbol +" Price: "+Ask;
             if (alertsMessage) Alert(lmessage);
             if (alertsNotify)  SendNotification(lmessage);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Buy signal "),lmessage);
             if (alertsSound)   PlaySound("alert2.wav");
             candletime=Time[0];
     }
}             
 
 
void scheckalert()
{              
   static datetime candletime=0;
  
   if(candletime!=Time[0])
     {
               
             string smessage = "ZOXY is Red, this means a sell signal! Pair: "+_Symbol +" Price: "+Bid;
             if (alertsMessage) Alert(smessage);
             if (alertsNotify)  SendNotification(smessage);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Sell signal "),smessage);
             if (alertsSound)   PlaySound("alert2.wav");
             candletime=Time[0];
     }
               
}

 